## hopscotch-map 2.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
include(GNUInstallDirs)


project(tsl-hopscotch-map VERSION 2.3.1)

add_library(hopscotch_map INTERFACE)
# Use tsl::hopscotch_map as target, more consistent with other libraries conventions (Boost, Qt, ...)
add_library(tsl::hopscotch_map ALIAS hopscotch_map)

target_include_directories(hopscotch_map INTERFACE
                           "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
                           "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")

list(APPEND headers "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl/bhopscotch_map.h"
                    "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl/bhopscotch_set.h"
                    "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl/hopscotch_growth_policy.h"
                    "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl/hopscotch_hash.h"
                    "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl/hopscotch_map.h"
                    "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl/hopscotch_set.h")
target_sources(hopscotch_map INTERFACE "$<BUILD_INTERFACE:${headers}>")

if(MSVC)
    target_sources(hopscotch_map INTERFACE
                   "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tsl-hopscotch-map.natvis>"
                   "$<INSTALL_INTERFACE:${CMAKE_INSTALL_DATAROOTDIR}/tsl-hopscotch-map.natvis>")
endif()




# Installation (only compatible with CMake version >= 3.3)
if(${CMAKE_VERSION} VERSION_GREATER "3.2")
    include(CMakePackageConfigHelpers)

    ## Install include directory and potential natvis file
    install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl"
            DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

    if(MSVC)
        install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/tsl-hopscotch-map.natvis"
                DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}")
    endif()



    ## Create and install tsl-hopscotch-mapConfig.cmake
    configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/tsl-hopscotch-mapConfig.cmake.in"
                                  "${CMAKE_CURRENT_BINARY_DIR}/tsl-hopscotch-mapConfig.cmake"
                                  INSTALL_DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/cmake/tsl-hopscotch-map")

    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tsl-hopscotch-mapConfig.cmake"
            DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/cmake/tsl-hopscotch-map")



    ## Create and install tsl-hopscotch-mapTargets.cmake
    install(TARGETS hopscotch_map
            EXPORT tsl-hopscotch-mapTargets)

    install(EXPORT tsl-hopscotch-mapTargets
            NAMESPACE tsl::
            DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/cmake/tsl-hopscotch-map")



    ## Create and install tsl-hopscotch-mapConfigVersion.cmake
    # tsl-hopscotch-map is header-only and does not depend on the architecture.
    # Remove CMAKE_SIZEOF_VOID_P from tsl-hopscotch-mapConfigVersion.cmake so that a
    # tsl-hopscotch-mapConfig.cmake generated for a 64 bit target can be used for 32 bit
    # targets and vice versa.
    set(CMAKE_SIZEOF_VOID_P_BACKUP ${CMAKE_SIZEOF_VOID_P})
    unset(CMAKE_SIZEOF_VOID_P)
    write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/tsl-hopscotch-mapConfigVersion.cmake"
                                     COMPATIBILITY SameMajorVersion)
    set(CMAKE_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P_BACKUP})

    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tsl-hopscotch-mapConfigVersion.cmake"
            DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/cmake/tsl-hopscotch-map")
endif()

## hopscotch-map 2.2.1

=== debian/changelog ===
hopscotch-map (2.2.1-3) unstable; urgency=medium

  * Rules-Requires-Root: no
  * Convert to Architecture: all package to aid cross building of reverse
    build-depends and save archive space
  * Standards-Version: 4.5.0 (routine-update)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 18 Feb 2020 12:24:07 +0100

hopscotch-map (2.2.1-2) unstable; urgency=medium

  * Add g++ to the autopkgtest dependencies

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 09 Jan 2020 20:01:37 +0100

hopscotch-map (2.2.1-1) unstable; urgency=medium

  * Initial release (Closes: #946638)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 12 Dec 2019 13:38:02 +0100

=== debian/control ===
Source: hopscotch-map
Section: libdevel
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libboost-test-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/hopscotch-map
Vcs-Git: https://salsa.debian.org/med-team/hopscotch-map.git
Homepage: https://github.com/Tessil/hopscotch-map/
Rules-Requires-Root: no

Package: libtsl-hopscotch-map-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: C++ fast hash map and hash set using hopscotch hashing
 The hopscotch-map library is a C++ implementation of a fast hash map and hash
 set using open-addressing and hopscotch hashing to resolve collisions. It is a
 cache-friendly data structure offering better performances than
 `std::unordered_map` in most cases and is closely similar to
 `google::dense_hash_map` while using less memory and providing more
 functionalities.
 .
 The library provides the following main classes: `tsl::hopscotch_map`,
 `tsl::hopscotch_set`, `tsl::hopscotch_pg_map` and `tsl::hopscotch_pg_set`. The
 first two are faster and use a power of two growth policy, the last two use a
 prime growth policy instead and are able to cope better with a poor hash
 function. Use the prime version if there is a chance of repeating patterns in
 the lower bits of your hash (e.g. you are storing pointers with an identity
 hash function).
 .
 In addition to these classes the library also provides `tsl::bhopscotch_map`,
 `tsl::bhopscotch_set`, `tsl::bhopscotch_pg_map` and `tsl::bhopscotch_pg_set`.
 These classes have an additional requirement for the key, it must be
 `LessThanComparable`, but they provide a better asymptotic upper bound.
 Nonetheless if you don't have specific requirements (risk of hash DoS attacks),
 `tsl::hopscotch_map` and `tsl::hopscotch_set` should be sufficient in most
 cases and should be your default pick as they perform better in general.

=== debian/watch ===
version=4

https://github.com/Tessil/hopscotch-map/releases .*/archive/v?@ANY_VERSION@@ARCHIVE_EXT@

## hopscotch-map 2.3.0

=== debian/changelog ===
hopscotch-map (2.3.0-3) unstable; urgency=medium

  * Team upload
  * Cherry-pick upstream patch to fix undefined behaviour with C++17
    and later standards
  * routine-update: Standards-Version: 4.6.1

 -- Balint Reczey <balint@balintreczey.hu>  Fri, 08 Jul 2022 23:42:29 +0200

hopscotch-map (2.3.0-2) unstable; urgency=medium

  * Team upload
  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 22 Aug 2021 10:00:19 +0200

hopscotch-map (2.3.0-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 29 Jun 2020 13:27:55 +0200

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: libdevel
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
-Build-Depends: debhelper-compat (= 12),
+Uploaders: Michael R. Crusoe <crusoe@debian.org>
+Build-Depends: debhelper-compat (= 13),
                cmake,
                libboost-test-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/hopscotch-map
 Vcs-Git: https://salsa.debian.org/med-team/hopscotch-map.git
 Homepage: https://github.com/Tessil/hopscotch-map/

=== debian/watch ===
version=4

https://github.com/Tessil/hopscotch-map/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## hopscotch-map 2.3.1

=== debian/changelog ===
hopscotch-map (2.3.1-2) unstable; urgency=medium

  * Team upload.
  * Fix build with CMake 4
    Closes: #1112993
  * d/watch: version=5
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 21 Oct 2025 07:20:53 +0200

hopscotch-map (2.3.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 12 Jul 2023 22:01:19 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,14 @@
 Source: hopscotch-map
+Standards-Version: 4.7.2
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders:
+ Michael R. Crusoe <crusoe@debian.org>,
 Section: libdevel
 Priority: optional
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Michael R. Crusoe <crusoe@debian.org>
-Build-Depends: debhelper-compat (= 13),
-               cmake,
-               libboost-test-dev
-Standards-Version: 4.6.1
+Build-Depends:
+ debhelper-compat (= 13),
+ cmake,
+ libboost-test-dev,
 Vcs-Browser: https://salsa.debian.org/med-team/hopscotch-map
 Vcs-Git: https://salsa.debian.org/med-team/hopscotch-map.git
 Homepage: https://github.com/Tessil/hopscotch-map/
@@ -15,7 +17,8 @@
 Package: libtsl-hopscotch-map-dev
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}
+Depends:
+ ${misc:Depends},
 Description: C++ fast hash map and hash set using hopscotch hashing
  The hopscotch-map library is a C++ implementation of a fast hash map and hash
  set using open-addressing and hopscotch hashing to resolve collisions. It is a

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

# for hardening you might like to uncomment this:
# export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_POLICY_VERSION_MINIMUM=3.5
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_configure --sourcedirectory=tests --builddirectory=build-tests -- -DCMAKE_POLICY_VERSION_MINIMUM=3.5
endif

override_dh_auto_build:
	dh_auto_build
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_build --sourcedirectory=tests --builddirectory=build-tests
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd build-tests && ./tsl_hopscotch_map_tests
endif

=== debian/watch ===
Version: 5

Template: Github
Owner: Tessil
Project: hopscotch-map
